%% Convex optimization of Graph Laplacian 
clc;
clear all;
close all;

%%  stage agent Ѹ neighor Ѵ.
make_agent_formation; % <= ⼭ stage agent 
pos_xy = [];
for ai = 1:stage.nr_agent
    pos_xy = [pos_xy ; agents{ai}.pos];
end

%%   agent Ad D L Ѵ. 
s  = 10; % Ÿ  weight decay ϴ .
Ad = make_adjacency_matrix(agents, stage, s);
D  = diag(sum(Ad));
L  = D - Ad; 

%% Incidence matrix A ϰ L Ѵ. 
[A w] = make_incidence_matrix(agents, stage, s);
sumw = sum(w); 
w = w/sumw;
L2 = A*diag(w)*A';
L  = L / sumw;

%%    ȮѴ. 
L, L2 
evs = eig(L2);
ev2_org = evs(2);

%% 1. Fastest Mixing Markov Chain 
disp('1. Fastest Mixing Markov Chain ');
[w_fmmc, cvx_optval ] = fmmc(A); 
L_fmmc = A*diag(w_fmmc)*A';
evs = eig(L_fmmc);
ev2_fmmc = evs(2);
fprintf('FMMC lambda2 = %.4f, Org lambda2 = %.4f \n\n' ...
    , ev2_fmmc, ev2_org);

%% 2. Fastest Mixing Markov Process 
disp('2. Fastest Mixing Markov Process ');
[w_fmmp, cvx_optval ] = fmmp2(A); 
L_fmmp = A*diag(w_fmmp)*A';
evs = eig(L_fmmp);
ev2_fmmp = evs(2);
fprintf('FMMP lambda2 = %.4f, Org lambda2 = %.4f \n\n' ...
    , ev2_fmmp, ev2_org);

%% 3. Minimum Total Effective Resistance 
disp('3. Minimum Total Effective Resistance ');
[ w_mter, cvx_optval ] = mter(A);
L_mter = A*diag(w_mter)*A';
evs = eig(L_mter);
ev2_mter = evs(2);
fprintf('MTER lambda2 = %.4f, Org lambda2 = %.4f \n\n' ...
    , ev2_mter, ev2_org);

%% 4. Fast averaging
disp('4. Fast averaging');
[ w_fdla, cvx_optval ] = fdla(A);
L_fdla = A*diag(w_fdla)*A';
evs = eig(L_fdla);
ev2_fdla = evs(2);
fprintf('FDLA lambda2 = %.4f, Org lambda2 = %.4f \n\n' ...
    , ev2_fdla, ev2_org);

%% ׷ ׷ Ȯغ. 
figure('Position', [100 100 1000 800]);
subplot(221);
title_str = sprintf('Original Graph lmd2 = %.4f', ev2_org);
plotgraph(A, pos_xy, w', title_str);
subplot(222);
title_str = sprintf('Fastest Mixing Markov Chain  Graph lmd2 = %.4f', ev2_fmmc);
plotgraph(A, pos_xy, w_fmmc', title_str);
subplot(223);
title_str = sprintf('Fastest Mixing Markov Process  Graph lmd2 = %.4f', ev2_fmmp);
plotgraph(A, pos_xy, w_fmmp', title_str);
subplot(224);
title_str = sprintf('Minimum Total Effective Resistance  Graph lmd2 = %.4f', ev2_mter);
plotgraph(A, pos_xy, w_mter', title_str);

%% 








