%% Multi-agent formation . 
make_new_formation = 0;
plot_formation     = 1;

%% Multi-agent formation . (Ȥ ҷ´.)
if make_new_formation
    stage.nr_agent  = 10;    % Agent 
    stage.xmin = 0; stage.xmax = 10; stage.w = 10;   
    stage.ymin = 0; stage.ymax = 10; stage.h = 10;
    stage.nei_radius  = 5;
    agents = cell(stage.nr_agent, 1);
    for ai = 1:stage.nr_agent
        agents{ai}.pos = [stage.xmin+stage.w*rand() stage.ymin+stage.h*rand()];
    end
    for ai = 1:stage.nr_agent 
        agents{ai}.nei = [];
        for aj = 1:stage.nr_agent
            if ai == aj, continue; end;
            dist_ij = norm(agents{ai}.pos-agents{aj}.pos);
            if dist_ij <= stage.nei_radius
                agents{ai}.nei = [agents{ai}.nei aj ];
            end
        end
    end
    save('MultiAgentFormation.mat', 'stage', 'agents');
else
    load('MultiAgentFormation.mat');
end

%% agent neighbor plotѴ.
if plot_formation
    figure();
    hold on;
    for ai = 1:stage.nr_agent
        plot(agents{ai}.pos(1), agents{ai}.pos(2)...
            , 's' ...
            , 'LineWidth', 2 ...
            , 'MarkerEdgeColor','k' ...
            , 'MarkerFaceColor','g' ...
            , 'MarkerSize',10)
        str = sprintf('  [%d]', ai);
        text(agents{ai}.pos(1), agents{ai}.pos(2), str);
        for nj = agents{ai}.nei
            plot([agents{ai}.pos(1) agents{nj}.pos(1)], ...
                [agents{ai}.pos(2) agents{nj}.pos(2)], 'b-');
        end
    end
    axis([stage.xmin stage.xmax stage.ymin stage.ymax]);
    grid on; hold off;
    title('Multi-Agent Coordination');
end 


%%
clear make_new_formation;
clear plot_formation;
